unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, Spin;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.SpinEdit1Change(Sender: TObject);
var i,j:integer;
begin
 // toroljuk a cellak tartalmat
 for i:=0 to 9 do
   for j:=0 to 9 do StringGrid1.Cells[i,j]:='';
 // a rendezes gombot nem elerhetove tesszuk
 Button2.Enabled := false;
 // beallitjuk a sorok es oszlopok szamat
 StringGrid1.ColCount := SpinEdit1.Value;
 StringGrid1.RowCount := SpinEdit1.Value;
 // beallitjuk a StringGrid szelesseget es magassagat
 // minden cella 31 szeles(magas) a vonalal egyutt az egyik szelen
 // + 3 a StringGrig keretenek szelessege(magassaga)
 StringGrid1.Width := 31 * SpinEdit1.Value + 3;
 StringGrid1.Height := 31 * SpinEdit1.Value + 3;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i,j:integer;
begin
 // a cellakba 10-99 kozotti veletlen szamokat generalunk
 // az oszlopok(sorok) 0-tol vannak szamozva !!
 for i:=0 to StringGrid1.ColCount-1 do
  for j:=0 to StringGrid1.RowCount-1 do
    StringGrid1.Cells[i,j] := IntToStr(random(90)+10);
 // a rendezes gombot elerhetove tesszuk
 Button2.Enabled := true;
end;

procedure TForm1.Button2Click(Sender: TObject);
var i,j,ei,ej:integer;
    s:string;
    csere:boolean;
begin
 // a StringGrid1-el dolgozunk. Az alabbi sor kiadasaval nem
 // kell mindig megadnunk hogy pl. StringGrid1.Cells[i,j],
 // helyette eleg a Cells[i,j] a with parancson belul.
 with StringGrid1 do
  repeat
  ei := 0; // elozo cella sorindexe
  ej := 0; // elozo cella oszlopindexe
  csere := false; // azt jelzi, volt-e csere (false=nem volt)
  for j:=0 to RowCount-1 do
    for i:=0 to ColCount-1 do
      begin
      // osszehasonlitjuk az aktualis cellat az elozovel
      if StrToInt(Cells[i,j])<StrToInt(Cells[ei,ej]) then
        begin
        s := Cells[i,j];
        Cells[i,j] := Cells[ei,ej];
        Cells[ei,ej] := s;
        csere := true;
        end;
      // beallitjuk az elozo cellat az aktualis cellara
      ei := i;
      ej := j;
      end;
  until not csere; // addig megyunk vegig az egesz StringGrid-en,
                   // amig igaz nem lesz, hogy csere=false;
 // a rendezes gombot nem elerhetove tesszuk,
 // mivel mar rendezve vannak a szamok
 Button2.Enabled := false;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 // a program inditasakor beallitjuk a veletlenszam generatort
 randomize;
end;

end.
